package org.example.entity;

import com.fasterxml.jackson.databind.PropertyNamingStrategy;
import com.fasterxml.jackson.databind.annotation.JsonNaming;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@AllArgsConstructor
@NoArgsConstructor
@Builder
@JsonNaming(PropertyNamingStrategy.SnakeCaseStrategy.class)
public class QuickStartEntity {

    private Long id;
    private String name;
    private String status;
    private String userCategory;
    private String statusName;
    private String userCategoryName;

    private CompanyInfoEntity companyInfo;

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    @Builder
    @JsonNaming(PropertyNamingStrategy.SnakeCaseStrategy.class)
    public static class CompanyInfoEntity {
        private Long id;
        private String companyName;
        private String companyType;
        private String companyTypeName;
        private String companyTypeDesc;
        private CompanyAdditionInfoEntity companyAdditionInfo;
    }

    @Data
    @AllArgsConstructor
    @NoArgsConstructor
    @Builder
    @JsonNaming(PropertyNamingStrategy.SnakeCaseStrategy.class)
    public static class CompanyAdditionInfoEntity {
        private String creditType;
        private String creditLevel;
        private String creditTypeName;
    }
}
