package org.example.repository.impl;

import org.example.entity.QuickStartEntity;
import org.example.entity.QuickStartEntity.CompanyInfoEntity;
import org.example.repository.QuickStartRepository;
import org.springframework.stereotype.Repository;

import java.util.*;
import java.util.stream.Collectors;

@Repository
public class QuickStartRepositoryImpl implements QuickStartRepository {

    private final Map<Long, QuickStartEntity> map;

    public QuickStartRepositoryImpl() {
        map = new LinkedHashMap<>();

        map.put(1L, QuickStartEntity.builder()
                .id(1L)
                .name("Some Name 1")
                .status("1")
                .userCategory("1")
                .companyInfo(CompanyInfoEntity.builder()
                        .id(1L)
                        .companyName("Some Company")
                        .companyType("C")
                        .companyAdditionInfo(QuickStartEntity.CompanyAdditionInfoEntity.builder()
                                .creditType("2")
                                .creditLevel("A")
                                .build())
                        .build())
                .build());

        map.put(2L, QuickStartEntity.builder()
                .id(2L)
                .name("Some Name 2")
                .status("1")
                .userCategory("2")
                .companyInfo(new CompanyInfoEntity())
                .build());
    }

    @SuppressWarnings("RedundantIfStatement")
    @Override
    public List<QuickStartEntity> list(QuickStartEntity query) {
        return map.values().stream().filter(entity -> {
            if (query.getId() != null && !Objects.equals(query.getId(), entity.getId())) {
                return false;
            }
            return true;
        }).collect(Collectors.toList());
    }
}
